Index: uspace/srv/net/inetsrv/inet_link.h
===================================================================
--- uspace/srv/net/inetsrv/inet_link.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/inet_link.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -38,5 +38,4 @@
 #define INET_LINK_H_
 
-#include <inet/eth_addr.h>
 #include <stddef.h>
 #include <stdint.h>
@@ -46,5 +45,5 @@
 extern errno_t inet_link_send_dgram(inet_link_t *, addr32_t,
     addr32_t, inet_dgram_t *, uint8_t, uint8_t, int);
-extern errno_t inet_link_send_dgram6(inet_link_t *, eth_addr_t *, inet_dgram_t *,
+extern errno_t inet_link_send_dgram6(inet_link_t *, addr48_t, inet_dgram_t *,
     uint8_t, uint8_t, int);
 extern inet_link_t *inet_link_get_by_id(sysarg_t);
Index: uspace/srv/net/inetsrv/inetcfg.c
===================================================================
--- uspace/srv/net/inetsrv/inetcfg.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/inetcfg.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2013 Jiri Svoboda
  * All rights reserved.
  *
@@ -177,7 +177,7 @@
 	linfo->def_mtu = ilink->def_mtu;
 	if (ilink->mac_valid) {
-		linfo->mac_addr = ilink->mac;
+		addr48(ilink->mac, linfo->mac_addr);
 	} else {
-		memset(&linfo->mac_addr, 0, sizeof(linfo->mac_addr));
+		memset(linfo->mac_addr, 0, sizeof(linfo->mac_addr));
 	}
 
Index: uspace/srv/net/inetsrv/inetsrv.h
===================================================================
--- uspace/srv/net/inetsrv/inetsrv.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/inetsrv.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,5 +41,4 @@
 #include <stdbool.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
 #include <inet/iplink.h>
 #include <ipc/loc.h>
@@ -110,5 +109,5 @@
 	iplink_t *iplink;
 	size_t def_mtu;
-	eth_addr_t mac;
+	addr48_t mac;
 	bool mac_valid;
 } inet_link_t;
Index: uspace/srv/net/inetsrv/ndp.c
===================================================================
--- uspace/srv/net/inetsrv/ndp.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/ndp.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2013 Antonin Steinhauser
  * All rights reserved.
@@ -37,8 +36,7 @@
 
 #include <errno.h>
-#include <inet/eth_addr.h>
-#include <io/log.h>
 #include <mem.h>
 #include <stdlib.h>
+#include <io/log.h>
 #include "ntrans.h"
 #include "addrobj.h"
@@ -71,5 +69,5 @@
 	ndp_pdu_encode(packet, &dgram);
 
-	inet_link_send_dgram6(link, &packet->target_hw_addr, &dgram,
+	inet_link_send_dgram6(link, packet->target_hw_addr, &dgram,
 	    IP_PROTO_ICMPV6, INET6_HOP_LIMIT_MAX, 0);
 
@@ -110,5 +108,5 @@
 		if (laddr != NULL) {
 			rc = ntrans_add(packet.sender_proto_addr,
-			    &packet.sender_hw_addr);
+			    packet.sender_hw_addr);
 			if (rc != EOK)
 				return rc;
@@ -117,7 +115,7 @@
 
 			reply.opcode = ICMPV6_NEIGHBOUR_ADVERTISEMENT;
-			reply.sender_hw_addr = laddr->ilink->mac;
+			addr48(laddr->ilink->mac, reply.sender_hw_addr);
 			addr128(packet.target_proto_addr, reply.sender_proto_addr);
-			reply.target_hw_addr = packet.sender_hw_addr;
+			addr48(packet.sender_hw_addr, reply.target_hw_addr);
 			addr128(packet.sender_proto_addr, reply.target_proto_addr);
 
@@ -130,5 +128,5 @@
 		if (laddr != NULL)
 			return ntrans_add(packet.sender_proto_addr,
-			    &packet.sender_hw_addr);
+			    packet.sender_hw_addr);
 
 		break;
@@ -153,5 +151,5 @@
  *
  */
-errno_t ndp_translate(addr128_t src_addr, addr128_t ip_addr, eth_addr_t *mac_addr,
+errno_t ndp_translate(addr128_t src_addr, addr128_t ip_addr, addr48_t mac_addr,
     inet_link_t *ilink)
 {
@@ -169,8 +167,8 @@
 
 	packet.opcode = ICMPV6_NEIGHBOUR_SOLICITATION;
-	packet.sender_hw_addr = ilink->mac;
+	addr48(ilink->mac, packet.sender_hw_addr);
 	addr128(src_addr, packet.sender_proto_addr);
 	addr128(ip_addr, packet.solicited_ip);
-	eth_addr_solicited_node(ip_addr, &packet.target_hw_addr);
+	addr48_solicited_node(ip_addr, packet.target_hw_addr);
 	ndp_solicited_node_ip(ip_addr, packet.target_proto_addr);
 
Index: uspace/srv/net/inetsrv/ndp.h
===================================================================
--- uspace/srv/net/inetsrv/ndp.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/ndp.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2013 Antonin Steinhauser
  * All rights reserved.
@@ -40,5 +39,4 @@
 
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
 #include "inetsrv.h"
 #include "icmpv6_std.h"
@@ -54,9 +52,9 @@
 	ndp_opcode_t opcode;
 	/** Sender hardware address */
-	eth_addr_t sender_hw_addr;
+	addr48_t sender_hw_addr;
 	/** Sender protocol address */
 	addr128_t sender_proto_addr;
 	/** Target hardware address */
-	eth_addr_t target_hw_addr;
+	addr48_t target_hw_addr;
 	/** Target protocol address */
 	addr128_t target_proto_addr;
@@ -66,5 +64,5 @@
 
 extern errno_t ndp_received(inet_dgram_t *);
-extern errno_t ndp_translate(addr128_t, addr128_t, eth_addr_t *, inet_link_t *);
+extern errno_t ndp_translate(addr128_t, addr128_t, addr48_t, inet_link_t *);
 
 #endif
Index: uspace/srv/net/inetsrv/ntrans.c
===================================================================
--- uspace/srv/net/inetsrv/ntrans.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/ntrans.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2013 Antonin Steinhauser
  * All rights reserved.
@@ -39,5 +38,4 @@
 #include <errno.h>
 #include <fibril_synch.h>
-#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
 #include <stdlib.h>
@@ -75,5 +73,5 @@
  *
  */
-errno_t ntrans_add(addr128_t ip_addr, eth_addr_t *mac_addr)
+errno_t ntrans_add(addr128_t ip_addr, addr48_t mac_addr)
 {
 	inet_ntrans_t *ntrans;
@@ -85,5 +83,5 @@
 
 	addr128(ip_addr, ntrans->ip_addr);
-	ntrans->mac_addr = *mac_addr;
+	addr48(mac_addr, ntrans->mac_addr);
 
 	fibril_mutex_lock(&ntrans_list_lock);
@@ -136,5 +134,5 @@
  *
  */
-errno_t ntrans_lookup(addr128_t ip_addr, eth_addr_t *mac_addr)
+errno_t ntrans_lookup(addr128_t ip_addr, addr48_t mac_addr)
 {
 	fibril_mutex_lock(&ntrans_list_lock);
@@ -146,5 +144,5 @@
 
 	fibril_mutex_unlock(&ntrans_list_lock);
-	*mac_addr = ntrans->mac_addr;
+	addr48(ntrans->mac_addr, mac_addr);
 	return EOK;
 }
Index: uspace/srv/net/inetsrv/ntrans.h
===================================================================
--- uspace/srv/net/inetsrv/ntrans.h	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/ntrans.h	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2013 Antonin Steinhauser
  * All rights reserved.
@@ -39,7 +38,6 @@
 #define NTRANS_H_
 
+#include <inet/iplink_srv.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
-#include <inet/iplink_srv.h>
 
 /** Address translation table element */
@@ -47,10 +45,10 @@
 	link_t ntrans_list;
 	addr128_t ip_addr;
-	eth_addr_t mac_addr;
+	addr48_t mac_addr;
 } inet_ntrans_t;
 
-extern errno_t ntrans_add(addr128_t, eth_addr_t *);
+extern errno_t ntrans_add(addr128_t, addr48_t);
 extern errno_t ntrans_remove(addr128_t);
-extern errno_t ntrans_lookup(addr128_t, eth_addr_t *);
+extern errno_t ntrans_lookup(addr128_t, addr48_t);
 extern errno_t ntrans_wait_timeout(usec_t);
 
Index: uspace/srv/net/inetsrv/pdu.c
===================================================================
--- uspace/srv/net/inetsrv/pdu.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/inetsrv/pdu.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -40,5 +40,4 @@
 #include <errno.h>
 #include <fibril_synch.h>
-#include <inet/eth_addr.h>
 #include <io/log.h>
 #include <macros.h>
@@ -505,5 +504,5 @@
 
 	message->length = 1;
-	eth_addr_encode(&ndp->sender_hw_addr, message->mac);
+	addr48(ndp->sender_hw_addr, message->mac);
 
 	icmpv6_phdr_t phdr;
@@ -553,5 +552,5 @@
 
 	addr128_t_be2host(message->target_address, ndp->target_proto_addr);
-	eth_addr_decode(message->mac, &ndp->sender_hw_addr);
+	addr48(message->mac, ndp->sender_hw_addr);
 
 	return EOK;
Index: uspace/srv/net/loopip/loopip.c
===================================================================
--- uspace/srv/net/loopip/loopip.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/loopip/loopip.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2012 Jiri Svoboda
  * All rights reserved.
  *
@@ -41,5 +41,4 @@
 #include <inet/iplink_srv.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
 #include <io/log.h>
 #include <loc.h>
@@ -56,5 +55,5 @@
 static errno_t loopip_send6(iplink_srv_t *srv, iplink_sdu6_t *sdu);
 static errno_t loopip_get_mtu(iplink_srv_t *srv, size_t *mtu);
-static errno_t loopip_get_mac48(iplink_srv_t *srv, eth_addr_t *mac);
+static errno_t loopip_get_mac48(iplink_srv_t *srv, addr48_t *mac);
 static errno_t loopip_addr_add(iplink_srv_t *srv, inet_addr_t *addr);
 static errno_t loopip_addr_remove(iplink_srv_t *srv, inet_addr_t *addr);
@@ -232,5 +231,5 @@
 }
 
-static errno_t loopip_get_mac48(iplink_srv_t *src, eth_addr_t *mac)
+static errno_t loopip_get_mac48(iplink_srv_t *src, addr48_t *mac)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "loopip_get_mac48()");
Index: uspace/srv/net/slip/slip.c
===================================================================
--- uspace/srv/net/slip/slip.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/srv/net/slip/slip.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,3 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
  * Copyright (c) 2013 Jakub Jermar
  * All rights reserved.
@@ -41,5 +40,4 @@
 #include <loc.h>
 #include <inet/addr.h>
-#include <inet/eth_addr.h>
 #include <inet/iplink_srv.h>
 #include <io/chardev.h>
@@ -64,5 +62,5 @@
 static errno_t slip_send6(iplink_srv_t *, iplink_sdu6_t *);
 static errno_t slip_get_mtu(iplink_srv_t *, size_t *);
-static errno_t slip_get_mac48(iplink_srv_t *, eth_addr_t *);
+static errno_t slip_get_mac48(iplink_srv_t *, addr48_t *);
 static errno_t slip_addr_add(iplink_srv_t *, inet_addr_t *);
 static errno_t slip_addr_remove(iplink_srv_t *, inet_addr_t *);
@@ -178,5 +176,5 @@
 }
 
-errno_t slip_get_mac48(iplink_srv_t *src, eth_addr_t *mac)
+errno_t slip_get_mac48(iplink_srv_t *src, addr48_t *mac)
 {
 	log_msg(LOG_DEFAULT, LVL_DEBUG, "slip_get_mac48()");
